﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_PreInit(object sender, EventArgs e)
    {
        List<string> keys = Request.Form.AllKeys.Where(key => key.Contains("txtDynamic")).ToList();
        int i = 1;
        foreach (string key in keys)
        {
            this.CreateTextBox("txtDynamic" + i, i);
            i++;
        }
    }

    protected void AddTextBox(object sender, EventArgs e)
    {
        int index = pnlTextBoxes.Controls.OfType<TextBox>().ToList().Count + 1;
        this.CreateTextBox("txtDynamic" + index, index);
    }

    private void CreateTextBox(string id, int index)
    {
        TextBox txt = new TextBox();
        txt.ID = id;
        pnlTextBoxes.Controls.Add(txt);

        RequiredFieldValidator req = new RequiredFieldValidator();
        req.ID = "rfvDynamic" + index;
        req.ForeColor = System.Drawing.Color.Red;
        req.SetFocusOnError = true;
        req.ErrorMessage = " Required";
        req.Display = ValidatorDisplay.Dynamic;
        req.ControlToValidate = id;
        pnlTextBoxes.Controls.Add(req);

        RegularExpressionValidator rev = new RegularExpressionValidator();
        rev.ID = "revPhone" + index;
        rev.ControlToValidate = id;
        rev.ForeColor = System.Drawing.Color.Red;
        rev.Display = ValidatorDisplay.Dynamic;
        rev.ValidationExpression = "^([0-9]{10})$";
        rev.ErrorMessage = " Invalid Phone Number.";

        pnlTextBoxes.Controls.Add(rev);
    }

    protected void Validate(object sender, EventArgs e)
    {
        string message = "";
        foreach (TextBox textBox in pnlTextBoxes.Controls.OfType<TextBox>())
        {
            message += "Value of " + textBox.ID + " is " + textBox.Text + "\\n";
        }
        ClientScript.RegisterClientScriptBlock(this.GetType(), "alert", "alert('" + message + "');", true);
    }
}